#define _CRT_SECURE_NO_WARNINGS
#define  _CRT_NON_CONFORMING_SWPRINTFS
#include "font.h"

// RXgN^
DirectXText::DirectXText()
{
	pFont = NULL;
}

// fXgN^
DirectXText::~DirectXText()
{
	if(pFont != NULL)
		pFont->Release();
}

// DirectXtHg쐬
bool DirectXText::Create(IDirect3DDevice9* pD3DDevice,int FontHeight)
{
	HFONT	hFont = NULL;	// tHgnh
	LOGFONT	LogFont ={};	// tHg\

	// ftHgtHg擾
	hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	// ftHgtHg擾
	GetObject( hFont, sizeof(LOGFONT), &LogFont);
	// DirectXtHg쐬
	if(FAILED(D3DXCreateFont(pD3DDevice, 
		FontHeight,					// 
		LogFont.lfWidth,			// 
		LogFont.lfWeight,			// tHg̑
		0,							// ~bv}bvx
		LogFont.lfItalic,			// C^bNtO
		LogFont.lfCharSet,			// Zbg
		LogFont.lfOutPrecision,		// ۂ̃tHgƖړĨtHg̓̈v@
		LogFont.lfQuality,			// NHeB
		LogFont.lfPitchAndFamily,	// sb`ƃt@~CfbNX
		LogFont.lfFaceName,			// tHg
		&pFont)))
	{
		return false;
	}
	

	return true;
}


// ̕`
void DirectXText::Draw(DWORD Color,int x,int y,const TCHAR* Str,...)
{
	va_list args;
	va_start( args, Str );					// ψ̍ŏ̗vfi[
	int len = _vsctprintf( Str, args ) + 1;	// JEgAk
	if(Buf.size() < (UINT)len)
		Buf.resize(len);						// TCYIɃm
	_vstprintf( &Buf[0], Str, args );			// 𐮌`

	SetRect( &Rect, 0,0,0,0 );
	// `̈TCY擾
	pFont->DrawText(NULL, &Buf[0], -1, &Rect, DT_LEFT | DT_CALCRECT, Color);
	// {`
	Rect.left += x;
	Rect.right += x;
	Rect.top += y;
	Rect.bottom += y;
	pFont->DrawText(NULL, &Buf[0], -1, &Rect, DT_LEFT, Color);
}